package db

import (
	"context"
	"time"
	"youngee_b_api/model/gorm_model"

	"github.com/sirupsen/logrus"
)

//新增
func CreatePayRecord(ctx context.Context, enterpriseId int64, payment int64, balance int64, payType int64, projectId int64) (*int64, error) {
	db := GetReadDB(ctx)
	payRecord := gorm_model.EnterprisePayRecord{
		EnterpriseID: enterpriseId,
		Payment:      payment,
		Balance:      balance,
		PayType:      payType,
		PayAt:        time.Now(),
		ProjectID:    projectId,
	}
	err := db.Create(&payRecord).Error
	if err != nil {
		logrus.WithContext(ctx).Errorf("[logistics db] call CreatePayRecord error,err:%+v", err)
		return nil, err
	}

	return &payRecord.ID, nil
}
