package handler

import (
	"youngee_b_api/consts"
	"youngee_b_api/model/http_model"
	"youngee_b_api/service"
	"youngee_b_api/util"

	"github.com/sirupsen/logrus"

	"github.com/gin-gonic/gin"
)

// WrapProjectChangeTaskStatusHandler
// @BasePath /youngee/m/
// SendCode godoc
// @Summary ProjectChangeTaskStatus 更改项目任务状态
// @Schemes
// @Description  更改项目任务的状态
// @Accept json
// @Produce json
// @Param req body http_model.ProjectChangeTaskStatusRequest true "更改项目任务状态的请求结构体"
// @Success 200 {object} http_model.CommonResponse{} "更改项目任务状态相应结构体"
// @Router /product/changeTaskStatus [post]
func WrapRecruitStrategyNumberCalculate(ctx *gin.Context) {
	handler := newRecruitStrategyNumberCalculate(ctx)
	baseRun(handler)
}

func newRecruitStrategyNumberCalculate(ctx *gin.Context) *RecruitStrategyNumberCalculateHandler {
	return &RecruitStrategyNumberCalculateHandler{
		req:  http_model.NewRecruitStrategyNumberCalculateRequst(),
		resp: http_model.NewRecruitStrategyNumberCalculateResponse(),
		ctx:  ctx,
	}
}

type RecruitStrategyNumberCalculateHandler struct {
	req  *http_model.RecruitStrategyNumberCalculateRequest
	resp *http_model.CommonResponse
	ctx  *gin.Context
}

func (p *RecruitStrategyNumberCalculateHandler) getContext() *gin.Context {
	return p.ctx
}

func (p *RecruitStrategyNumberCalculateHandler) getResponse() interface{} {
	return p.resp
}

func (p *RecruitStrategyNumberCalculateHandler) getRequest() interface{} {
	return p.req
}

func (p *RecruitStrategyNumberCalculateHandler) run() {
	data := http_model.RecruitStrategyNumberCalculateRequest{}
	data = *p.req
	err := service.Recruitstrategy.RecruitStrategyNumberCalculate(p.ctx, data)
	if err != nil {
		logrus.Errorf("[ChangeTaskStatusHandler] call Create err:%+v\n", err)
		util.HandlerPackErrorResp(p.resp, consts.ErrorInternal, "")
		logrus.Info("ChangeTaskStatus fail,req:%+v", p.req)
		return
	}
	p.resp.Message = "已选数量变更成功"
}

func (p *RecruitStrategyNumberCalculateHandler) checkParam() error {
	return nil
}
